{
  "openapi": "3.1.0",
  "info": {
    "version": "2.0",
    "title": "GoTab API",
    "license": {
      "name": "ISC",
      "identifier": "ISC"
    },
    "description": "The GoTab REST API lets you integrate with the GoTab platform for ordering, payments, catalog management, and more.\n\n## Authentication\n\nAll API requests require a Bearer token. Obtain one via the **Generate Access Token** endpoint (`POST /oauth/token`) using your `api_access_id` and `api_access_secret`.\n\nTokens expire after 24 hours. Use the **Refresh Token** endpoint (`POST /oauth/refresh`) to get a new token without re-authenticating.\n\n## Base URL\n\n```\nhttps://gotab.io/api\n```\n\n## Rate Limits\n\n- Standard: 100 requests/minute\n- Premium: 1,000 requests/minute\n\n## Need Help?\n\nContact developer support at api.support@gotab.io or visit https://docs.gotab.io",
    "contact": {
      "name": "GoTab Developer Support",
      "email": "api.support@gotab.io",
      "url": "https://docs.gotab.io"
    }
  },
  "components": {
    "securitySchemes": {
      "bearerAuth": {
        "type": "http",
        "scheme": "bearer",
        "bearerFormat": "JWT",
        "description": "Access token obtained from POST /oauth/token. Pass as: Authorization: Bearer <token>"
      }
    },
    "schemas": {
      "ApiErrorWarningModel": {
        "description": "The standard format for errors and warnings.",
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "type": {
              "description": "A unique error code representing the error.",
              "type": "string"
            },
            "message": {
              "description": "A human readable message describing the error.",
              "type": "string"
            }
          }
        }
      },
      "ApiResponseModel": {
        "properties": {
          "data": {
            "type": "object"
          },
          "errors": {
            "$ref": "#/components/schemas/ApiErrorWarningModel"
          },
          "warnings": {
            "$ref": "#/components/schemas/ApiErrorWarningModel"
          }
        }
      },
      "ArchiveScheduleInput": {
        "type": "object",
        "properties": {
          "schedule": {
            "anyOf": [
              {
                "type": "string"
              },
              {
                "type": "object",
                "properties": {
                  "laborScheduleUuid": {
                    "type": "string"
                  }
                },
                "required": [
                  "laborScheduleUuid"
                ],
                "additionalProperties": false
              }
            ]
          }
        },
        "required": [
          "schedule"
        ],
        "additionalProperties": false
      },
      "AttachModifierProduct": {
        "anyOf": [
          {
            "type": "string",
            "description": "The product identifier"
          },
          {
            "type": "object",
            "properties": {
              "name": {
                "type": "string"
              },
              "description": {
                "type": "string",
                "description": "An optional description of the modifier."
              },
              "externalId": {
                "type": "string",
                "description": "An optional external identifier for this modifier"
              },
              "shortName": {
                "type": [
                  "string",
                  "null"
                ],
                "default": null
              },
              "price": {
                "type": "integer",
                "default": 0,
                "description": "Price in cents"
              },
              "enabled": {
                "type": "boolean",
                "default": true,
                "description": "Whether this modifier is enabled"
              },
              "require": {
                "type": "boolean",
                "default": false,
                "description": "Whether this modifier is required"
              },
              "allowOptionQuantities": {
                "type": "boolean",
                "default": false
              },
              "productId": {
                "type": "string",
                "description": "The product identifier"
              },
              "productUuid": {
                "type": "string",
                "description": "The product identifier"
              },
              "sku": {
                "type": "string",
                "description": "A custom sku to attach to this modifier. When not provided one will be generated."
              }
            },
            "additionalProperties": false
          }
        ]
      },
      "AuthTokenModel": {
        "required": [
          "token",
          "refreshToken",
          "tokenType",
          "initiated",
          "expires",
          "expiresIn"
        ],
        "properties": {
          "token": {
            "type": "string"
          },
          "refreshToken": {
            "type": "string"
          },
          "tokenType": {
            "type": "string"
          },
          "initiated": {
            "type": "number"
          },
          "expires": {
            "type": "number"
          },
          "expiresIn": {
            "type": "number"
          }
        }
      },
      "CreateScheduleInput": {
        "type": "object",
        "properties": {
          "userId": {
            "type": "string",
            "description": "GoTab user ID"
          },
          "externalUserId": {
            "type": "string",
            "description": "External ID of a user already mapped to their GoTab user"
          },
          "startTime": {
            "type": "string",
            "description": "Start time of the shift in UTC"
          },
          "endTime": {
            "type": "string",
            "description": "End time of the shift in UTC"
          },
          "userRoleId": {
            "type": "string",
            "description": "GoTab user role ID"
          },
          "externalUserRoleId": {
            "type": "string",
            "description": "External ID of a user role already mapped to a GoTab user role"
          },
          "fulfilled": {
            "type": "string",
            "description": "Time of shift fulfillment in UTC"
          }
        },
        "required": [
          "userId",
          "startTime",
          "endTime"
        ],
        "additionalProperties": false
      },
      "CreateUserInput": {
        "description": "The payment method",
        "type": "object",
        "properties": {
          "firstName": {
            "type": "string",
            "description": "The first name of the user"
          },
          "lastName": {
            "type": "string",
            "description": "The last name of the user"
          },
          "acl": {
            "type": "string",
            "description": "The access control list for the user"
          },
          "displayName": {
            "type": "string",
            "description": "A desired display name for the user, normally used in interfaces. If not supplied will default to `firstName + lastName`"
          },
          "phoneNumber": {
            "type": "string",
            "description": "The phone number of the user. If not supplied the user will be created as a restricted user with limited permission"
          },
          "posPin": {
            "type": "string",
            "description": "The POS pin for the user. The length of the pin should match the length configured for the location"
          },
          "payRate": {
            "type": "number",
            "description": "The pay rate of the user in the smallest unit of the currency of the location. Used as the default pay rate of any supplied user roles. Has no effect if `userRoles` is not supplied"
          },
          "userRoles": {
            "type": "array",
            "description": "The user roles for the user. Must match an existing role at the location",
            "items": {
              "type": "object",
              "properties": {
                "userRole": {
                  "type": "string",
                  "description": "The userRoleUuid or name of the user role to assign to the user"
                },
                "payRate": {
                  "type": "number",
                  "description": "The pay rate of the user in the smallest unit of the currency of the location. Overrides the pay rate of the user role itself. If not provided will use the pay rate of the request if any"
                }
              }
            }
          },
          "sendSms": {
            "type": "boolean",
            "description": "Whether to send a SMS to the created user. Defaults to `false`"
          },
          "email": {
            "type": "string",
            "description": "The email address of the user"
          },
          "aclAgentConfig": {
            "type": "object",
            "description": "Agent-specific configuration to store on the user's acl (e.g. `clockin_enforced`, or an external system's user id). Fully replaces any existing value for this location's acl row — it does not merge, so a partial write clears the keys it omits. Read the current value from `GET /users` and merge client-side to preserve keys you do not own. Omit the field to leave the stored config untouched; pass `{}` to clear it."
          },
          "metadata": {
            "type": "object",
            "description": "Arbitrary additional metadata to store on the user (e.g. an external system's user id). Shallow-merged with existing metadata."
          }
        }
      },
      "CustomerChallengeRequest": {
        "type": "object",
        "properties": {
          "customerHandle": {
            "type": "string",
            "description": "Customer handle to challenge (e.g. phone number or email)."
          }
        },
        "required": [
          "customerHandle"
        ],
        "additionalProperties": false
      },
      "CustomerChallengeResponse": {
        "type": "object",
        "properties": {
          "customerId": {
            "type": "string",
            "description": "Opaque identifier for the customer record associated to the challenge."
          }
        },
        "required": [
          "customerId"
        ],
        "additionalProperties": false
      },
      "CustomerVerifyRequest": {
        "type": "object",
        "properties": {
          "customerId": {
            "type": "string",
            "description": "Unresolved GoTab customer identifier to verify."
          },
          "verificationCode": {
            "type": "string",
            "description": "OTP verification code for the customer."
          },
          "paymentSessionId": {
            "type": "string",
            "description": "Optional payment session identifier for issuing a wallet token."
          },
          "tabUuid": {
            "type": "string",
            "description": "Optional tab UUID associated to the payment session."
          },
          "locationId": {
            "type": "string",
            "description": "Optional location ID associated to the tab."
          }
        },
        "required": [
          "customerId",
          "verificationCode"
        ],
        "additionalProperties": false
      },
      "CustomerVerifyResponse": {
        "type": "object",
        "properties": {
          "verified": {
            "type": "boolean",
            "description": "Whether the customer verification succeeded."
          },
          "customerId": {
            "type": "string",
            "description": "Resolved customer_id"
          },
          "paymentSessionToken": {
            "type": "string",
            "description": "Optional payment session token returned after successful verification."
          }
        },
        "required": [
          "verified"
        ],
        "additionalProperties": false
      },
      "ErrorAlertsModel": {
        "type": "object",
        "properties": {
          "alerts": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/ApiErrorWarningModel"
            }
          }
        }
      },
      "IntegrationCustomerInput": {
        "description": "The integration customer input",
        "type": "object",
        "properties": {
          "customerFirstName": {
            "type": "string",
            "description": "The first name of the customer"
          },
          "customerLastName": {
            "type": "string",
            "description": "The last name of the customer"
          },
          "handle": {
            "type": "string",
            "description": "The phone number for the customer"
          }
        }
      },
      "IntegrationCustomerResponse": {
        "description": "The integration customer response",
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "name": {
              "type": "string",
              "description": "The name of the customer"
            },
            "handle": {
              "type": "string",
              "description": "The phone number for the customer"
            },
            "customer_profile_uuid": {
              "type": "string",
              "description": "The customerProfileUuid assigned to the customer"
            }
          }
        }
      },
      "InventoryComponent": {
        "type": "object",
        "properties": {
          "sku": {
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "type": {
            "type": [
              "string",
              "null"
            ]
          },
          "units": {
            "type": "string"
          },
          "price": {
            "type": [
              "string",
              "null"
            ]
          },
          "stock_level": {
            "type": [
              "number",
              "null"
            ]
          },
          "inventory_level": {
            "type": [
              "number",
              "null"
            ]
          },
          "impacts_availability": {
            "type": [
              "boolean",
              "null"
            ]
          },
          "parent_product_id": {},
          "parent_product_name": {
            "type": [
              "string",
              "null"
            ]
          },
          "minus_one_components": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "sku": {
                  "type": "string"
                },
                "conversion_factor": {
                  "type": "number"
                }
              }
            }
          },
          "plus_one_components": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "sku": {
                  "type": "string"
                },
                "conversion_factor": {
                  "type": "number"
                }
              }
            }
          },
          "product_ids": {
            "type": "array",
            "items": {}
          },
          "products": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "product_id": {},
                "product_uuid": {
                  "type": [
                    "string",
                    "null"
                  ]
                },
                "name": {
                  "type": [
                    "string",
                    "null"
                  ]
                }
              }
            }
          },
          "is_lowest_level": {
            "type": "boolean"
          },
          "kds_visible": {
            "type": "boolean"
          },
          "router_ids": {
            "type": [
              "array",
              "null"
            ],
            "items": {
              "type": "integer"
            }
          }
        },
        "required": [
          "sku",
          "name",
          "units",
          "minus_one_components",
          "plus_one_components",
          "product_ids",
          "products",
          "is_lowest_level",
          "kds_visible"
        ]
      },
      "InventoryItem": {
        "type": "object",
        "properties": {
          "productId": {
            "type": "string"
          },
          "productUuid": {
            "type": "string"
          },
          "externalId": {
            "type": "string"
          },
          "variants": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "name": {
                  "type": "string"
                },
                "sku": {
                  "type": "string"
                },
                "isStocked": {
                  "type": "boolean"
                },
                "isDetached": {
                  "type": "boolean"
                },
                "isTracked": {
                  "type": "boolean"
                },
                "quantity": {
                  "type": "integer"
                },
                "mappings": {
                  "type": "array",
                  "items": {
                    "type": "string"
                  }
                }
              },
              "required": [
                "name",
                "sku",
                "isStocked",
                "isDetached",
                "isTracked",
                "quantity",
                "mappings"
              ],
              "additionalProperties": false
            }
          },
          "updatedAt": {
            "type": "string"
          }
        },
        "required": [
          "productId",
          "productUuid",
          "externalId",
          "variants",
          "updatedAt"
        ],
        "additionalProperties": false
      },
      "InventoryProduct": {
        "type": "object",
        "properties": {
          "productId": {
            "type": "string"
          },
          "locationId": {
            "type": "string"
          },
          "productUuid": {
            "type": "string"
          },
          "externalId": {
            "type": "string"
          },
          "variants": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "productId": {
                  "type": "string"
                },
                "locationId": {
                  "type": "string"
                },
                "inventoryId": {
                  "type": "string"
                },
                "externalInventoryId": {
                  "type": "string",
                  "description": "Deprecated: use `external_sku` instead. The external inventory id mapped to this variant inventory."
                },
                "externalSku": {
                  "type": "string",
                  "description": "The external sku mapped to this variant inventory."
                },
                "sku": {
                  "type": "string",
                  "description": "The GoTab assigned SKU of the variant. This property cannot be updated."
                },
                "name": {
                  "type": "string"
                },
                "variant": {
                  "type": "object",
                  "additionalProperties": {
                    "type": "string"
                  },
                  "description": "Variant Designations - A record of variant names mapped to the variant value. Eg: `{\"size\": \"large\", \"color\": \"red\"}`. This designation uniquely identifies an inventory product variant."
                },
                "isStocked": {
                  "type": "boolean"
                },
                "isDetached": {
                  "type": "boolean"
                },
                "isTracked": {
                  "type": "boolean"
                },
                "stockLevel": {
                  "type": "number"
                },
                "externalSkuIds": {
                  "type": "array",
                  "items": {
                    "type": "string"
                  },
                  "description": "Deprecated: use `barcodes` instead. A list of external SKU ids (eg barcodes) mapped to the product variant."
                },
                "barcodes": {
                  "type": "array",
                  "items": {
                    "type": "string"
                  },
                  "description": "A list of barcodes mapped to the product variant."
                }
              },
              "required": [
                "productId",
                "locationId",
                "inventoryId",
                "externalInventoryId",
                "externalSku",
                "sku",
                "name",
                "variant",
                "isStocked",
                "isDetached",
                "isTracked",
                "stockLevel",
                "externalSkuIds"
              ],
              "additionalProperties": false
            }
          },
          "name": {
            "type": "string"
          },
          "updatedAt": {
            "type": "string"
          }
        },
        "required": [
          "productId",
          "locationId",
          "productUuid",
          "externalId",
          "variants",
          "name",
          "updatedAt"
        ],
        "additionalProperties": false
      },
      "InventoryTransferInput": {
        "type": "object",
        "properties": {
          "supplierId": {
            "type": "number",
            "description": "An external ID of the integrator or partner."
          },
          "adjustment": {
            "type": "number",
            "description": "Quantity of inventory being transferred."
          },
          "adjustmentReason": {
            "type": "string",
            "description": "A reason from an enumerated list: RECOUNT, RECEIVED, LOST, THEFT"
          },
          "cost": {
            "type": "number",
            "description": "Cost of goods being transferred."
          },
          "source": {
            "type": "object",
            "properties": {
              "sku": {
                "type": "string",
                "description": "The GoTab assigned SKU. This property cannot be updated."
              },
              "locationUuid": {
                "type": "string",
                "description": "The UUID of the GoTab location initiating the transfer."
              },
              "supplierId": {
                "type": "number",
                "description": "An external ID of the integrator or partner initiating the transfer."
              }
            },
            "required": [
              "sku"
            ],
            "additionalProperties": false
          }
        },
        "required": [
          "supplierId",
          "adjustment",
          "adjustmentReason"
        ],
        "additionalProperties": false
      },
      "InventoryTransferSource": {
        "type": "object",
        "properties": {
          "sku": {
            "type": "string",
            "description": "The GoTab assigned SKU. This property cannot be updated."
          },
          "locationUuid": {
            "type": "string",
            "description": "The UUID of the GoTab location initiating the transfer."
          },
          "supplierId": {
            "type": "number",
            "description": "An external ID of the integrator or partner initiating the transfer."
          }
        },
        "required": [
          "sku"
        ],
        "additionalProperties": false
      },
      "ItemInput": {
        "anyOf": [
          {
            "type": "object",
            "required": [
              "product",
              "quantity"
            ],
            "properties": {
              "product": {
                "anyOf": [
                  {
                    "type": "object",
                    "properties": {
                      "categoryName": {
                        "type": "string",
                        "description": "The name of the category the product belongs to."
                      },
                      "categoryUuid": {
                        "type": "string",
                        "description": "The unique uuid of the category the product belongs to."
                      },
                      "categoryId": {
                        "type": "string",
                        "description": "The unique id of the category the product belongs to."
                      },
                      "productName": {
                        "type": "string",
                        "description": "The name of the product."
                      },
                      "productId": {
                        "type": "string",
                        "description": "The unique id of the product."
                      },
                      "productUuid": {
                        "type": "string",
                        "description": "The unique uuid of the product."
                      }
                    }
                  },
                  {
                    "type": "string",
                    "description": "The unique uuid or id of the product to be added."
                  }
                ]
              },
              "name": {
                "type": "string",
                "description": "A custom name given to the item. This name is visible on the receipt and KDS.",
                "minLength": 3,
                "maxLength": 20
              },
              "unitPrice": {
                "type": "integer",
                "description": "The unit price of the open item in the lowest currency unit. ie cents.",
                "minimum": 1,
                "maximum": 100000
              },
              "quantity": {
                "type": "number",
                "description": "The quantity of items to be ordered."
              },
              "itemUnits": {
                "type": "string",
                "description": "Units that this item represents, e.g. 'oz', 'lbs', 'bottles', 'pints'. This value impacts how the item is viewed on the receipt."
              },
              "modifiers": {
                "$ref": "#/components/schemas/Modifiers"
              }
            },
            "title": "Catalog Item (v2)",
            "description": "An item created from a product in the catalog resolved by passing in properties of the item"
          },
          {
            "type": "object",
            "title": "Catalog Item (v1)",
            "description": "An item created from a product in the catalog resolved by passing in the productUuid. This is deprecated. Use Catalog Item (v2) instead",
            "required": [
              "productUuid",
              "quantity"
            ],
            "properties": {
              "externalId": {
                "type": "string",
                "description": "An external identifier for the item."
              },
              "quantity": {
                "type": "number",
                "description": "The quantity of items to be ordered."
              },
              "productUuid": {
                "type": "string",
                "description": "The unique uuid of the product to be added."
              },
              "modifiers": {
                "$ref": "#/components/schemas/Modifiers"
              }
            }
          },
          {
            "type": "object",
            "required": [
              "quantity",
              "name"
            ],
            "properties": {
              "externalId": {
                "type": "string",
                "description": "An external identifier for the open item."
              },
              "quantity": {
                "type": "number",
                "description": "The quantity of items to be ordered.",
                "minimum": 1
              },
              "name": {
                "type": "string",
                "description": "A name given to the open item. This name is visible on the receipt and KDS.",
                "minLength": 3,
                "maxLength": 20
              },
              "taxRate": {
                "oneOf": [
                  {
                    "type": "number",
                    "description": "A custom tax rate percentage to be applied to the item.",
                    "minimum": 0,
                    "maximum": 1
                  },
                  {
                    "type": "string",
                    "description": "The unique identifier of a ***tax rate group*** to be applied to the item. Ex: `txr_xxxxxxxxxxxxxxxx`."
                  },
                  {
                    "type": "array",
                    "description": "An array of tax identifiers that will resolve to a ***tax rate group*** if one exists and be applied to the item.",
                    "items": {
                      "type": "string",
                      "description": "The unique identifier of a _tax_ to be applied to the open item. Ex: `tax_xxxxxxxxxxxxxxxx`."
                    }
                  }
                ]
              },
              "unitPrice": {
                "type": "integer",
                "description": "The unit price of the open item in the lowest currency unit. ie cents.",
                "minimum": 1,
                "maximum": 100000
              },
              "itemUnits": {
                "type": "string",
                "description": "Units that this item represents, e.g. 'oz', 'lbs', 'bottles', 'pints'. This value impacts how the item is viewed on the receipt."
              },
              "modifiers": {
                "$ref": "#/components/schemas/Modifiers"
              }
            },
            "title": "Open Item",
            "description": "An pen item"
          }
        ]
      },
      "Modifier": {
        "anyOf": [
          {
            "type": "object",
            "properties": {
              "name": {
                "type": "string"
              },
              "description": {
                "type": "string",
                "description": "An optional description of the modifier."
              },
              "externalId": {
                "type": "string",
                "description": "An optional external identifier for this modifier"
              },
              "shortName": {
                "type": [
                  "string",
                  "null"
                ],
                "default": null
              },
              "price": {
                "type": "integer",
                "default": 0,
                "description": "Price in cents"
              },
              "enabled": {
                "type": "boolean",
                "default": true,
                "description": "Whether this modifier is enabled"
              },
              "require": {
                "type": "boolean",
                "default": false,
                "description": "Whether this modifier is required"
              },
              "allowOptionQuantities": {
                "type": "boolean",
                "default": false
              },
              "type": {
                "type": "string",
                "enum": [
                  "checkbox"
                ]
              },
              "minCount": {
                "type": [
                  "number",
                  "null"
                ],
                "minimum": 0,
                "default": 0
              },
              "maxCount": {
                "type": [
                  "number",
                  "null"
                ],
                "minimum": 1
              },
              "default": {
                "type": "boolean",
                "default": false
              },
              "product": {
                "type": "string",
                "description": "An optional inventory product to associated with this modifier."
              }
            },
            "required": [
              "name",
              "type"
            ],
            "additionalProperties": false,
            "description": "Checkbox Modifier - A modifier that can either be checked or unchecked"
          },
          {
            "type": "object",
            "properties": {
              "name": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/name"
              },
              "description": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/description"
              },
              "externalId": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/externalId"
              },
              "shortName": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/shortName"
              },
              "price": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/price"
              },
              "enabled": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/enabled"
              },
              "require": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/require"
              },
              "allowOptionQuantities": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/allowOptionQuantities"
              },
              "type": {
                "type": "string",
                "enum": [
                  "multi"
                ]
              },
              "minCount": {
                "type": "number",
                "minimum": 0,
                "default": 0
              },
              "maxCount": {
                "type": "number",
                "minimum": 1
              },
              "options": {
                "type": "array",
                "items": {
                  "anyOf": [
                    {
                      "$ref": "#/components/schemas/Modifier/anyOf/0"
                    },
                    {
                      "type": "string",
                      "description": "The name of the modifier. Defaults will be used for all other fields"
                    }
                  ],
                  "description": "Checkbox Modifier - A modifier that can either be checked or unchecked"
                },
                "description": "Multi Modifier Options - The options for this multi modifier"
              }
            },
            "required": [
              "name",
              "type",
              "options"
            ],
            "additionalProperties": false,
            "description": "Multi Modifier - A modifier allowing multiple checkbox modifiers to be selected"
          },
          {
            "type": "object",
            "properties": {
              "name": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/name"
              },
              "description": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/description"
              },
              "externalId": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/externalId"
              },
              "shortName": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/shortName"
              },
              "price": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/price"
              },
              "enabled": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/enabled"
              },
              "require": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/require"
              },
              "allowOptionQuantities": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/allowOptionQuantities"
              },
              "type": {
                "type": "string",
                "enum": [
                  "variant"
                ]
              },
              "minCount": {
                "$ref": "#/components/schemas/Modifier/anyOf/1/properties/minCount"
              },
              "maxCount": {
                "$ref": "#/components/schemas/Modifier/anyOf/1/properties/maxCount"
              },
              "options": {
                "type": "array",
                "items": {
                  "anyOf": [
                    {
                      "type": "object",
                      "properties": {
                        "name": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/name"
                        },
                        "description": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/description"
                        },
                        "externalId": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/externalId"
                        },
                        "shortName": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/shortName"
                        },
                        "enabled": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/enabled"
                        },
                        "require": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/require"
                        },
                        "allowOptionQuantities": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/allowOptionQuantities"
                        },
                        "type": {
                          "type": "string",
                          "enum": [
                            "variant-item"
                          ],
                          "default": "variant-item"
                        },
                        "minCount": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/minCount"
                        },
                        "maxCount": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/maxCount"
                        },
                        "default": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/default"
                        },
                        "product": {
                          "$ref": "#/components/schemas/Modifier/anyOf/0/properties/product"
                        },
                        "variantId": {
                          "type": "string",
                          "description": "The unique identifier of the variant this option represents"
                        }
                      },
                      "required": [
                        "name"
                      ],
                      "additionalProperties": false,
                      "description": "Checkbox Modifier - A modifier that can either be checked or unchecked"
                    },
                    {
                      "type": "string"
                    }
                  ],
                  "description": "Checkbox Modifier - A modifier that can either be checked or unchecked"
                },
                "description": "Variant Options - The options for this variant modifier"
              }
            },
            "required": [
              "name",
              "type",
              "options"
            ],
            "additionalProperties": false,
            "description": "Variant Modifier - A modifier representing a variant"
          },
          {
            "type": "object",
            "properties": {
              "name": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/name"
              },
              "description": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/description"
              },
              "externalId": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/externalId"
              },
              "shortName": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/shortName"
              },
              "price": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/price"
              },
              "enabled": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/enabled"
              },
              "require": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/require"
              },
              "allowOptionQuantities": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/allowOptionQuantities"
              },
              "type": {
                "type": "string",
                "enum": [
                  "select"
                ]
              },
              "enum": {
                "type": "array",
                "items": {
                  "type": "string"
                },
                "description": "The options for this modifier"
              }
            },
            "required": [
              "name",
              "type",
              "enum"
            ],
            "additionalProperties": false,
            "description": "A modifier intended to show a list of options to the user as a dropdown and allowing a single selection"
          },
          {
            "type": "object",
            "properties": {
              "name": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/name"
              },
              "description": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/description"
              },
              "externalId": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/externalId"
              },
              "shortName": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/shortName"
              },
              "price": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/price"
              },
              "enabled": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/enabled"
              },
              "require": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/require"
              },
              "allowOptionQuantities": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/allowOptionQuantities"
              },
              "type": {
                "type": "string",
                "enum": [
                  "textarea"
                ]
              },
              "minLength": {
                "type": "number",
                "minimum": 0
              },
              "maxLength": {
                "type": "number",
                "minimum": 1
              },
              "rows": {
                "type": "number",
                "minimum": 1
              }
            },
            "required": [
              "name",
              "type"
            ],
            "additionalProperties": false,
            "description": "Open Text Modifier - A modifier allowing arbitrary text input"
          },
          {
            "type": "object",
            "properties": {
              "name": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/name"
              },
              "description": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/description"
              },
              "externalId": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/externalId"
              },
              "shortName": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/shortName"
              },
              "price": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/price"
              },
              "enabled": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/enabled"
              },
              "require": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/require"
              },
              "allowOptionQuantities": {
                "$ref": "#/components/schemas/Modifier/anyOf/0/properties/allowOptionQuantities"
              },
              "type": {
                "type": "string",
                "enum": [
                  "radio"
                ]
              },
              "enum": {
                "type": "array",
                "items": {
                  "type": "string"
                },
                "description": "The options for this modifier"
              }
            },
            "required": [
              "name",
              "type",
              "enum"
            ],
            "additionalProperties": false,
            "description": "Radio Modifier - A modifier intended to show a list of options to the user as a radio button group and allowing a single selection"
          }
        ]
      },
      "ModifierInput": {
        "anyOf": [
          {
            "type": "object",
            "properties": {
              "key": {
                "type": "string",
                "description": "The key of the modifier."
              },
              "quantity": {
                "type": "number",
                "description": "The quantity of the modifier."
              }
            },
            "title": "Option (v1)"
          },
          {
            "type": "object",
            "properties": {
              "optionGroupHash": {
                "type": "string",
                "description": "The hash of the option group."
              },
              "options": {
                "type": "array",
                "description": "A list of options of the option group.",
                "items": {
                  "$ref": "#/components/schemas/OptionInput"
                }
              }
            },
            "title": "Option (v2)"
          }
        ]
      },
      "ModifierOrModifierReference": {
        "anyOf": [
          {
            "anyOf": [
              {
                "type": "object",
                "properties": {
                  "name": {
                    "type": "string"
                  },
                  "description": {
                    "type": "string",
                    "description": "An optional description of the modifier."
                  },
                  "externalId": {
                    "type": "string",
                    "description": "An optional external identifier for this modifier"
                  },
                  "shortName": {
                    "type": [
                      "string",
                      "null"
                    ],
                    "default": null
                  },
                  "price": {
                    "type": "integer",
                    "default": 0,
                    "description": "Price in cents"
                  },
                  "enabled": {
                    "type": "boolean",
                    "default": true,
                    "description": "Whether this modifier is enabled"
                  },
                  "require": {
                    "type": "boolean",
                    "default": false,
                    "description": "Whether this modifier is required"
                  },
                  "allowOptionQuantities": {
                    "type": "boolean",
                    "default": false
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "checkbox"
                    ]
                  },
                  "minCount": {
                    "type": [
                      "number",
                      "null"
                    ],
                    "minimum": 0,
                    "default": 0
                  },
                  "maxCount": {
                    "type": [
                      "number",
                      "null"
                    ],
                    "minimum": 1
                  },
                  "default": {
                    "type": "boolean",
                    "default": false
                  },
                  "product": {
                    "type": "string",
                    "description": "An optional inventory product to associated with this modifier."
                  }
                },
                "required": [
                  "name",
                  "type"
                ],
                "additionalProperties": false,
                "description": "Checkbox Modifier - A modifier that can either be checked or unchecked"
              },
              {
                "type": "object",
                "properties": {
                  "name": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/name"
                  },
                  "description": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/description"
                  },
                  "externalId": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/externalId"
                  },
                  "shortName": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/shortName"
                  },
                  "price": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/price"
                  },
                  "enabled": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/enabled"
                  },
                  "require": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/require"
                  },
                  "allowOptionQuantities": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/allowOptionQuantities"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "multi"
                    ]
                  },
                  "minCount": {
                    "type": "number",
                    "minimum": 0,
                    "default": 0
                  },
                  "maxCount": {
                    "type": "number",
                    "minimum": 1
                  },
                  "options": {
                    "type": "array",
                    "items": {
                      "anyOf": [
                        {
                          "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0"
                        },
                        {
                          "type": "string",
                          "description": "The name of the modifier. Defaults will be used for all other fields"
                        }
                      ],
                      "description": "Checkbox Modifier - A modifier that can either be checked or unchecked"
                    },
                    "description": "Multi Modifier Options - The options for this multi modifier"
                  }
                },
                "required": [
                  "name",
                  "type",
                  "options"
                ],
                "additionalProperties": false,
                "description": "Multi Modifier - A modifier allowing multiple checkbox modifiers to be selected"
              },
              {
                "type": "object",
                "properties": {
                  "name": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/name"
                  },
                  "description": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/description"
                  },
                  "externalId": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/externalId"
                  },
                  "shortName": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/shortName"
                  },
                  "price": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/price"
                  },
                  "enabled": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/enabled"
                  },
                  "require": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/require"
                  },
                  "allowOptionQuantities": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/allowOptionQuantities"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "variant"
                    ]
                  },
                  "minCount": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/1/properties/minCount"
                  },
                  "maxCount": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/1/properties/maxCount"
                  },
                  "options": {
                    "type": "array",
                    "items": {
                      "anyOf": [
                        {
                          "type": "object",
                          "properties": {
                            "name": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/name"
                            },
                            "description": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/description"
                            },
                            "externalId": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/externalId"
                            },
                            "shortName": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/shortName"
                            },
                            "enabled": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/enabled"
                            },
                            "require": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/require"
                            },
                            "allowOptionQuantities": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/allowOptionQuantities"
                            },
                            "type": {
                              "type": "string",
                              "enum": [
                                "variant-item"
                              ],
                              "default": "variant-item"
                            },
                            "minCount": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/minCount"
                            },
                            "maxCount": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/maxCount"
                            },
                            "default": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/default"
                            },
                            "product": {
                              "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/product"
                            },
                            "variantId": {
                              "type": "string",
                              "description": "The unique identifier of the variant this option represents"
                            }
                          },
                          "required": [
                            "name"
                          ],
                          "additionalProperties": false,
                          "description": "Checkbox Modifier - A modifier that can either be checked or unchecked"
                        },
                        {
                          "type": "string"
                        }
                      ],
                      "description": "Checkbox Modifier - A modifier that can either be checked or unchecked"
                    },
                    "description": "Variant Options - The options for this variant modifier"
                  }
                },
                "required": [
                  "name",
                  "type",
                  "options"
                ],
                "additionalProperties": false,
                "description": "Variant Modifier - A modifier representing a variant"
              },
              {
                "type": "object",
                "properties": {
                  "name": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/name"
                  },
                  "description": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/description"
                  },
                  "externalId": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/externalId"
                  },
                  "shortName": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/shortName"
                  },
                  "price": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/price"
                  },
                  "enabled": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/enabled"
                  },
                  "require": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/require"
                  },
                  "allowOptionQuantities": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/allowOptionQuantities"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "select"
                    ]
                  },
                  "enum": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    },
                    "description": "The options for this modifier"
                  }
                },
                "required": [
                  "name",
                  "type",
                  "enum"
                ],
                "additionalProperties": false,
                "description": "A modifier intended to show a list of options to the user as a dropdown and allowing a single selection"
              },
              {
                "type": "object",
                "properties": {
                  "name": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/name"
                  },
                  "description": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/description"
                  },
                  "externalId": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/externalId"
                  },
                  "shortName": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/shortName"
                  },
                  "price": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/price"
                  },
                  "enabled": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/enabled"
                  },
                  "require": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/require"
                  },
                  "allowOptionQuantities": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/allowOptionQuantities"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "textarea"
                    ]
                  },
                  "minLength": {
                    "type": "number",
                    "minimum": 0
                  },
                  "maxLength": {
                    "type": "number",
                    "minimum": 1
                  },
                  "rows": {
                    "type": "number",
                    "minimum": 1
                  }
                },
                "required": [
                  "name",
                  "type"
                ],
                "additionalProperties": false,
                "description": "Open Text Modifier - A modifier allowing arbitrary text input"
              },
              {
                "type": "object",
                "properties": {
                  "name": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/name"
                  },
                  "description": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/description"
                  },
                  "externalId": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/externalId"
                  },
                  "shortName": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/shortName"
                  },
                  "price": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/price"
                  },
                  "enabled": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/enabled"
                  },
                  "require": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/require"
                  },
                  "allowOptionQuantities": {
                    "$ref": "#/components/schemas/ModifierOrModifierReference/anyOf/0/anyOf/0/properties/allowOptionQuantities"
                  },
                  "type": {
                    "type": "string",
                    "enum": [
                      "radio"
                    ]
                  },
                  "enum": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    },
                    "description": "The options for this modifier"
                  }
                },
                "required": [
                  "name",
                  "type",
                  "enum"
                ],
                "additionalProperties": false,
                "description": "Radio Modifier - A modifier intended to show a list of options to the user as a radio button group and allowing a single selection"
              }
            ]
          },
          {
            "type": "string",
            "description": "modifier_uuid"
          },
          {
            "type": "object",
            "properties": {
              "modifierUuid": {
                "type": "string"
              }
            },
            "required": [
              "modifierUuid"
            ],
            "additionalProperties": false
          }
        ]
      },
      "Modifiers": {
        "type": "array",
        "description": "A list of modifiers.",
        "items": {
          "$ref": "#/components/schemas/ModifierInput"
        }
      },
      "OpenDiscountInput": {
        "description": "The integration customer input",
        "type": "object",
        "properties": {
          "discountType": {
            "type": "string",
            "description": "A reason from an enumerated list (percent, amount)."
          },
          "discountValue": {
            "type": "number",
            "description": "The amount of the discount in dollars."
          },
          "discountName": {
            "type": "string",
            "description": "The name of the discount."
          },
          "discountReason": {
            "type": "string",
            "description": "The reason for the discount."
          }
        }
      },
      "Operations": {
        "type": "array",
        "items": {
          "anyOf": [
            {
              "type": "object",
              "properties": {
                "operation": {
                  "type": "string",
                  "enum": [
                    "upsert-users"
                  ]
                },
                "operationId": {
                  "type": "string",
                  "description": "Optional identifier for individual operation, will be returned if operation throws an error."
                },
                "users": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "firstName": {
                        "type": "string"
                      },
                      "lastName": {
                        "type": "string"
                      },
                      "acl": {
                        "type": "string"
                      },
                      "phoneNumber": {
                        "type": "string",
                        "description": "Used to match existing user in GoTab."
                      },
                      "posPin": {
                        "type": "string",
                        "description": "Length of pos pin must match the length configured for the location."
                      },
                      "email": {
                        "type": "string"
                      },
                      "externalUserId": {
                        "type": "string",
                        "description": "Unique ID from external system for the user."
                      },
                      "userRoles": {
                        "type": "array",
                        "items": {
                          "anyOf": [
                            {
                              "anyOf": [
                                {
                                  "type": "string"
                                },
                                {
                                  "type": "number"
                                }
                              ],
                              "description": "Internal GoTab user role ID or UUID"
                            },
                            {
                              "type": "object",
                              "properties": {
                                "userRoleUuid": {
                                  "type": "string",
                                  "description": "GoTab user role UUID."
                                },
                                "userRoleId": {
                                  "type": "string",
                                  "description": "GoTab user role ID."
                                },
                                "externalUserRoleId": {
                                  "type": "string",
                                  "description": "Unique ID from external system for the user role."
                                },
                                "roleName": {
                                  "type": "string"
                                }
                              },
                              "additionalProperties": false
                            }
                          ],
                          "description": "Internal GoTab user role ID or UUID"
                        }
                      }
                    },
                    "required": [
                      "externalUserId"
                    ],
                    "additionalProperties": false
                  },
                  "minItems": 1
                }
              },
              "required": [
                "operation",
                "users"
              ],
              "additionalProperties": false,
              "description": "Update or insert one or more users",
              "title": "Upsert users"
            },
            {
              "type": "object",
              "properties": {
                "operation": {
                  "type": "string",
                  "enum": [
                    "delete-users"
                  ]
                },
                "operationId": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/0/properties/operationId"
                },
                "users": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/0/properties/users"
                }
              },
              "required": [
                "operation",
                "users"
              ],
              "additionalProperties": false,
              "description": "Archive one or more users",
              "title": "Delete users"
            },
            {
              "type": "object",
              "properties": {
                "operation": {
                  "type": "string",
                  "enum": [
                    "sync-users"
                  ]
                },
                "operationId": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/0/properties/operationId"
                },
                "users": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/0/properties/users"
                }
              },
              "required": [
                "operation",
                "users"
              ],
              "additionalProperties": false,
              "description": "Replace ALL users with the provided list. Use UPSERT if you do not want all outstanding users to be archived",
              "title": "Sync users"
            },
            {
              "type": "object",
              "properties": {
                "operation": {
                  "type": "string",
                  "enum": [
                    "upsert-roles"
                  ]
                },
                "operationId": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/0/properties/operationId"
                },
                "roles": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "externalUserRoleId": {
                        "type": "string",
                        "description": "Unique ID from external system for the user role."
                      },
                      "roleName": {
                        "type": "string"
                      },
                      "rate": {
                        "type": "number",
                        "description": "Pay rate associated with the user role."
                      }
                    },
                    "required": [
                      "externalUserRoleId",
                      "roleName"
                    ],
                    "additionalProperties": false
                  },
                  "minItems": 1
                }
              },
              "required": [
                "operation",
                "roles"
              ],
              "additionalProperties": false,
              "description": "Update or insert one or more user roles",
              "title": "Upsert user roles"
            },
            {
              "type": "object",
              "properties": {
                "operation": {
                  "type": "string",
                  "enum": [
                    "delete-roles"
                  ]
                },
                "operationId": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/0/properties/operationId"
                },
                "roles": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/3/properties/roles"
                }
              },
              "required": [
                "operation",
                "roles"
              ],
              "additionalProperties": false,
              "description": "Archive one or more user roles",
              "title": "Delete user roles"
            },
            {
              "type": "object",
              "properties": {
                "operation": {
                  "type": "string",
                  "enum": [
                    "sync-roles"
                  ]
                },
                "operationId": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/0/properties/operationId"
                },
                "roles": {
                  "$ref": "#/components/schemas/Operations/items/anyOf/3/properties/roles"
                }
              },
              "required": [
                "operation",
                "roles"
              ],
              "additionalProperties": false,
              "description": "Replace ALL user roles with the provided list. Use UPSERT if you do not want all outstanding roles to be archived",
              "title": "Sync user roles"
            }
          ],
          "description": "Operation\nUser or User Role operation to be performed"
        },
        "minItems": 1,
        "description": "Array of user and user role operations to be performed",
        "title": "Operations"
      },
      "OperationsErrorData": {
        "type": "object",
        "properties": {
          "code": {
            "type": "string",
            "description": "Error code"
          },
          "message": {
            "type": "string",
            "description": "Human readable message"
          },
          "statusCode": {
            "type": "number"
          },
          "details": {
            "type": "object",
            "properties": {
              "operation": {
                "type": "string",
                "description": "Name of operation where error occurred"
              },
              "index": {
                "type": "string",
                "description": "Index of role or user that failed"
              },
              "operationId": {
                "type": "string",
                "description": "Identifier for individual operation"
              }
            },
            "additionalProperties": false
          }
        },
        "required": [
          "details"
        ],
        "additionalProperties": false
      },
      "OperationsResponse": {
        "type": "object",
        "properties": {
          "data": {
            "type": "object",
            "properties": {
              "results": {
                "type": "array",
                "items": {
                  "type": "object",
                  "properties": {
                    "result": {},
                    "details": {
                      "type": "object",
                      "properties": {
                        "operationId": {
                          "type": "string",
                          "description": "Identifier for individual operation"
                        },
                        "index": {
                          "type": "string",
                          "description": "Operation index"
                        }
                      },
                      "additionalProperties": false
                    }
                  },
                  "additionalProperties": false
                }
              },
              "errors": {
                "type": "array",
                "items": {
                  "type": "object",
                  "properties": {
                    "code": {
                      "type": "string",
                      "description": "Error code"
                    },
                    "message": {
                      "type": "string",
                      "description": "Human readable message"
                    },
                    "statusCode": {
                      "type": "number"
                    },
                    "details": {
                      "type": "object",
                      "properties": {
                        "operation": {
                          "type": "object",
                          "properties": {},
                          "additionalProperties": false,
                          "description": "JSON data of operations passed in"
                        },
                        "index": {
                          "type": "string",
                          "description": "Index of operation that failed"
                        },
                        "operationId": {
                          "type": "string",
                          "description": "Identifier for individual operation that failed"
                        }
                      },
                      "additionalProperties": false
                    }
                  },
                  "additionalProperties": false
                }
              }
            },
            "additionalProperties": false
          }
        },
        "required": [
          "data"
        ],
        "additionalProperties": false
      },
      "OperationsResultData": {
        "type": "object",
        "properties": {
          "operation": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "externalId": {
                  "type": "string",
                  "description": "External user or user role ID"
                },
                "tableName": {
                  "type": "string",
                  "description": "Users or User Roles"
                },
                "id": {
                  "type": "string",
                  "description": "Internal ID now mapped to user or role"
                },
                "archived": {
                  "type": "boolean",
                  "description": "For delete operations"
                }
              },
              "additionalProperties": false
            }
          },
          "errors": {
            "type": "array",
            "items": {
              "type": "string"
            }
          }
        },
        "required": [
          "operation"
        ],
        "additionalProperties": false
      },
      "OptionInput": {
        "type": "object",
        "properties": {
          "option_hash": {
            "type": "string",
            "description": "The hash of the option."
          },
          "quantity": {
            "type": "number",
            "description": "The quantity of the option."
          }
        }
      },
      "PatchScheduleInput": {
        "type": "object",
        "properties": {
          "userId": {
            "type": "string",
            "description": "GoTab user ID"
          },
          "externalUserId": {
            "type": "string",
            "description": "External ID of a user already mapped to their GoTab user"
          },
          "startTime": {
            "type": "string",
            "description": "Start time of the shift in UTC"
          },
          "endTime": {
            "type": "string",
            "description": "End time of the shift in UTC"
          },
          "userRoleId": {
            "type": "string",
            "description": "GoTab user role ID"
          },
          "externalUserRoleId": {
            "type": "string",
            "description": "External ID of a user role already mapped to a GoTab user role"
          },
          "fulfilled": {
            "type": "string",
            "description": "Time of shift fulfillment in UTC"
          }
        },
        "additionalProperties": false
      },
      "PatchUserInput": {
        "description": "The payment method",
        "type": "object",
        "properties": {
          "firstName": {
            "type": "string",
            "description": "The first name of the user"
          },
          "lastName": {
            "type": "string",
            "description": "The last name of the user"
          },
          "acl": {
            "type": "string",
            "description": "The access control list for the user"
          },
          "displayName": {
            "type": "string",
            "description": "A desired display name for the user, normally used in interfaces. If not supplied will default to `firstName + lastName`"
          },
          "posPin": {
            "type": "string",
            "description": "The POS pin for the user. The length of the pin should match the length configured for the location"
          },
          "payRate": {
            "type": "number",
            "description": "The pay rate of the user in the smallest unit of the currency of the location. Used as the default pay rate of any supplied user roles. Has no effect if `userRoles` is not supplied"
          },
          "userRoles": {
            "type": "array",
            "description": "The user roles for the user. Must match an existing role at the location",
            "items": {
              "type": "object",
              "properties": {
                "role": {
                  "type": "string",
                  "description": "The userRoleUuid or name of the user role to assign to the user"
                },
                "payRate": {
                  "type": "number",
                  "description": "The pay rate of the user in the smallest unit of the currency of the location. Overrides the pay rate of the user role itself. If not provided will use the pay rate of the request if any"
                }
              }
            }
          },
          "email": {
            "type": "string",
            "description": "The email address of the user"
          },
          "aclAgentConfig": {
            "type": "object",
            "description": "Agent-specific configuration to store on the user's acl (e.g. `clockin_enforced`, or an external system's user id). Fully replaces any existing value for this location's acl row — it does not merge, so a partial write clears the keys it omits. Read the current value from `GET /users` and merge client-side to preserve keys you do not own. Omit the field to leave the stored config untouched; pass `{}` to clear it. Only applied when `acl` is also supplied."
          },
          "metadata": {
            "type": "object",
            "description": "Arbitrary additional metadata to store on the user (e.g. an external system's user id). Shallow-merged with existing metadata."
          }
        }
      },
      "PaymentIntent": {
        "type": "object",
        "properties": {
          "paymentIntentId": {
            "type": "string"
          },
          "paymentIntentUuid": {
            "type": "string"
          },
          "created": {
            "type": "string"
          },
          "updated": {
            "type": "string"
          },
          "amount": {
            "type": "number"
          },
          "tipAmount": {
            "type": "number"
          },
          "customerFee": {
            "type": "number"
          },
          "tabId": {
            "type": "string"
          },
          "locationId": {
            "type": "string"
          },
          "userId": {
            "type": "string"
          },
          "customerId": {
            "type": "string"
          },
          "paymentId": {
            "type": "string",
            "description": "The payment_id created by the payment intent when authorized"
          },
          "clientReference": {
            "type": "string",
            "description": "An optional reference string provided by the client"
          },
          "replayKey": {
            "type": "string",
            "description": "A unique key that is tied to this payment."
          },
          "notes": {
            "type": "string",
            "description": "Optional notes to associate with the payment intent"
          },
          "itemGroupUuid": {
            "type": "string",
            "description": "The UUID of the item group associated with the payment intent"
          },
          "isPreauth": {
            "type": "boolean",
            "default": false,
            "description": "Whether the payment intent is a pre-authorization"
          },
          "currency": {
            "type": "string",
            "enum": [
              "USD",
              "CAD",
              "AUS"
            ],
            "default": "USD",
            "description": "The currency of the payment intent"
          },
          "status": {
            "anyOf": [
              {
                "type": "string",
                "enum": [
                  "PENDING"
                ],
                "description": "The payment intent has been created but no checkout has started"
              },
              {
                "type": "string",
                "enum": [
                  "COLLECTING"
                ],
                "description": "The payment intent is in the process of collecting payment"
              },
              {
                "type": "string",
                "enum": [
                  "COLLECTED"
                ],
                "description": "The payment intent has successfully collected payment"
              },
              {
                "type": "string",
                "enum": [
                  "AUTHORIZING"
                ],
                "description": "The payment intent is in the process of authorizing payment"
              },
              {
                "type": "string",
                "enum": [
                  "AUTHORIZED"
                ],
                "description": "The payment intent has successfully authorized payment"
              },
              {
                "type": "string",
                "enum": [
                  "FAILED"
                ],
                "description": "The payment intent has failed"
              },
              {
                "type": "string",
                "enum": [
                  "AUTHORIZATION_FAILED"
                ],
                "description": "The payment intent failed to authorize payment"
              },
              {
                "type": "string",
                "enum": [
                  "CANCELED"
                ],
                "description": "The payment intent has been canceled"
              }
            ]
          },
          "latestMethod": {
            "type": "object",
            "properties": {
              "type": {
                "type": "string",
                "enum": [
                  "payment_terminal_checkout"
                ],
                "description": "The type of the latest payment method used"
              },
              "id": {
                "type": "string",
                "description": "The id associated with the latest payment method type"
              },
              "uuid": {
                "type": "string",
                "description": "The uuid associated with the latest payment method type"
              },
              "status": {
                "anyOf": [
                  {
                    "type": "string",
                    "enum": [
                      "IN_PROGRESS"
                    ],
                    "description": "The checkout is in progress"
                  },
                  {
                    "type": "string",
                    "enum": [
                      "SUCCESS"
                    ],
                    "description": "The checkout completed successfully"
                  },
                  {
                    "type": "string",
                    "enum": [
                      "FAILED"
                    ],
                    "description": "The checkout failed"
                  },
                  {
                    "type": "string",
                    "enum": [
                      "CANCELED"
                    ],
                    "description": "The checkout was canceled or timed out"
                  }
                ]
              },
              "created": {
                "type": "string"
              },
              "updated": {
                "type": "string"
              }
            },
            "required": [
              "type",
              "id",
              "uuid",
              "status",
              "created"
            ],
            "additionalProperties": false
          },
          "latestPaymentError": {
            "type": "object",
            "properties": {
              "code": {
                "type": "string",
                "description": "The error code associated with the latest payment error"
              },
              "message": {
                "type": "string",
                "description": "The error message associated with the latest payment error"
              },
              "detail": {
                "type": "string",
                "description": "Additional details about the latest payment error"
              }
            },
            "required": [
              "code",
              "message"
            ],
            "additionalProperties": false
          },
          "paymentDetails": {
            "type": "object",
            "properties": {
              "paymentId": {
                "type": "string",
                "description": "The ID of the payment associated with the payment intent"
              },
              "name": {
                "type": "string",
                "description": "The name on the payment method used"
              },
              "amount": {
                "type": "number",
                "description": "The amount charged in cents"
              },
              "tipAmount": {
                "type": "number",
                "description": "The tip amount charged in cents"
              },
              "customerFee": {
                "type": "number",
                "description": "The customer fee charged in cents"
              },
              "status": {
                "type": "string",
                "description": "The status of the payment"
              },
              "visualCue": {
                "type": "string",
                "description": "The last 4 digits representing the payment method used"
              }
            },
            "required": [
              "paymentId",
              "name",
              "amount",
              "tipAmount",
              "customerFee",
              "status",
              "visualCue"
            ],
            "additionalProperties": false
          }
        },
        "required": [
          "paymentIntentId",
          "paymentIntentUuid",
          "created",
          "amount",
          "tipAmount",
          "customerFee",
          "tabId",
          "locationId",
          "userId",
          "customerId",
          "clientReference",
          "replayKey",
          "status"
        ],
        "additionalProperties": false
      },
      "PaymentIntentErrorResponse": {
        "type": "object",
        "properties": {
          "data": {
            "type": "null"
          },
          "warnings": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "type": {
                  "type": "string"
                },
                "message": {}
              },
              "required": [
                "type"
              ],
              "additionalProperties": false
            }
          },
          "errors": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "type": {
                  "type": "string"
                },
                "message": {},
                "details": {}
              },
              "required": [
                "type"
              ],
              "additionalProperties": false
            }
          }
        },
        "required": [
          "data",
          "errors"
        ],
        "additionalProperties": false
      },
      "PaymentIntentRequestBody": {
        "type": "object",
        "properties": {
          "tabUuid": {
            "type": "string",
            "description": "The tab_uuid of the tab to associate this payment intent with"
          },
          "amount": {
            "type": "number",
            "description": "The amount to deduct from the tab balance in cents. Negative values are accepted for refund mode tabs and normalized server-side."
          },
          "clientReference": {
            "type": "string",
            "description": "An optional reference string provided by the client"
          },
          "replayKey": {
            "type": "string",
            "description": "A unique key that is tied to this payment."
          },
          "notes": {
            "type": "string",
            "description": "Optional notes to associate with the payment intent"
          },
          "itemGroupUuid": {
            "type": "string"
          },
          "isPreauth": {
            "type": "boolean",
            "default": false
          },
          "currency": {
            "type": "string",
            "enum": [
              "USD",
              "CAD",
              "AUS"
            ],
            "default": "USD"
          }
        },
        "required": [
          "tabUuid",
          "amount",
          "replayKey"
        ],
        "additionalProperties": false
      },
      "PaymentIntentResponse": {
        "type": "object",
        "properties": {
          "data": {
            "type": "object",
            "properties": {
              "paymentIntentId": {
                "type": "string"
              },
              "paymentIntentUuid": {
                "type": "string"
              },
              "created": {
                "type": "string"
              },
              "updated": {
                "type": "string"
              },
              "amount": {
                "type": "number"
              },
              "tipAmount": {
                "type": "number"
              },
              "customerFee": {
                "type": "number"
              },
              "tabId": {
                "type": "string"
              },
              "locationId": {
                "type": "string"
              },
              "userId": {
                "type": "string"
              },
              "customerId": {
                "type": "string"
              },
              "paymentId": {
                "type": "string",
                "description": "The payment_id created by the payment intent when authorized"
              },
              "clientReference": {
                "type": "string",
                "description": "An optional reference string provided by the client"
              },
              "replayKey": {
                "type": "string",
                "description": "A unique key that is tied to this payment."
              },
              "notes": {
                "type": "string",
                "description": "Optional notes to associate with the payment intent"
              },
              "itemGroupUuid": {
                "type": "string",
                "description": "The UUID of the item group associated with the payment intent"
              },
              "isPreauth": {
                "type": "boolean",
                "default": false,
                "description": "Whether the payment intent is a pre-authorization"
              },
              "currency": {
                "type": "string",
                "enum": [
                  "USD",
                  "CAD",
                  "AUS"
                ],
                "default": "USD",
                "description": "The currency of the payment intent"
              },
              "status": {
                "anyOf": [
                  {
                    "type": "string",
                    "enum": [
                      "PENDING"
                    ],
                    "description": "The payment intent has been created but no checkout has started"
                  },
                  {
                    "type": "string",
                    "enum": [
                      "COLLECTING"
                    ],
                    "description": "The payment intent is in the process of collecting payment"
                  },
                  {
                    "type": "string",
                    "enum": [
                      "COLLECTED"
                    ],
                    "description": "The payment intent has successfully collected payment"
                  },
                  {
                    "type": "string",
                    "enum": [
                      "AUTHORIZING"
                    ],
                    "description": "The payment intent is in the process of authorizing payment"
                  },
                  {
                    "type": "string",
                    "enum": [
                      "AUTHORIZED"
                    ],
                    "description": "The payment intent has successfully authorized payment"
                  },
                  {
                    "type": "string",
                    "enum": [
                      "FAILED"
                    ],
                    "description": "The payment intent has failed"
                  },
                  {
                    "type": "string",
[...]
